//+------------------------------------------------------------------+
//|                                             Steop stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_minimum -1
#property indicator_maximum 101

//
//
//
//
//

extern int    UsePrice        = PRICE_CLOSE;
extern int    ATR.Length      =  10;
extern double K.Slow          =   1;
extern double K.Fast          =   1;
extern int    Window          = 256;
extern int    PreSmoothPeriod =   5;
extern int    PreSmoothPhase  =   0;

//
//
//
//
//

double stoch1[];
double stoch2[];
double atr[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,stoch2);
   SetIndexBuffer(1,stoch1);
   SetIndexBuffer(2,atr);
      IndicatorShortName("Step stochastic )"+ATR.Length+","+DoubleToStr(K.Slow,2)+","+DoubleToStr(K.Fast,2)+","+Window+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][12];
#define k.SminMin   0
#define k.SmaxMin   1
#define k.SminMid   2
#define k.SmaxMid   3
#define k.SminMax   4
#define k.SmaxMax   5
#define k.TrendMin  6
#define k.TrendMid  7
#define k.TrendMax  8
#define k.linemin   9 
#define k.linemid  10
#define k.linemax  11
#define bigValue   99999999

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double nPrice = iSmooth(iMA(NULL,0,1,0,MODE_SMA,UsePrice,i),PreSmoothPeriod,PreSmoothPhase,i);  
             atr[i] = iATR(NULL,0,ATR.Length,i);
             if (r<=Window)
             {
                  work[r][k.TrendMin] = 0;
                  work[r][k.TrendMid] = 0;
                  work[r][k.TrendMax] = 0;
                  work[r][k.linemin]  = 0;
                  work[r][k.linemid]  = 0;
                  work[r][k.linemax]  = 0;
                  work[r][k.SminMin]  = bigValue;
                  work[r][k.SmaxMin]  = bigValue;
                  work[r][k.SminMax]  = 0;
                  work[r][k.SmaxMax]  = 0;
                  work[r][k.SminMid]  = 0;
                  work[r][k.SmaxMid]  = 0;
                  continue;
             }

      //
      //
      //
      //
      //
      
         double nATRmax     = atr[ArrayMaximum(atr,Window,i)];
         double nATRmin     = atr[ArrayMinimum(atr,Window,i)];
         double StepSizeMin = (K.Fast * nATRmin);
         double StepSizeMax = (K.Fast * nATRmax);
         double StepSizeMid = (K.Fast * 0.5 * K.Slow * (nATRmax + nATRmin));

            work[r][k.SmaxMin] = nPrice + 2.0 * StepSizeMin;
            work[r][k.SminMin] = nPrice - 2.0 * StepSizeMin;
            work[r][k.SmaxMax] = nPrice + 2.0 * StepSizeMax;
            work[r][k.SminMax] = nPrice - 2.0 * StepSizeMax;
            work[r][k.SmaxMid] = nPrice + 2.0 * StepSizeMid;
            work[r][k.SminMid] = nPrice - 2.0 * StepSizeMid;

            //
            //
            //
            //
            //
         
            double TrendMin = work[r-1][k.TrendMin];
            double TrendMid = work[r-1][k.TrendMid];
            double TrendMax = work[r-1][k.TrendMax];
            double linemin  = work[r-1][k.linemin];
            double linemid  = work[r-1][k.linemid];
            double linemax  = work[r-1][k.linemax];

            //
            //
            //
            //
            //
                        
            if (nPrice > work[r-1][k.SmaxMin]) TrendMin =  1;
            if (nPrice < work[r-1][k.SminMin]) TrendMin = -1;
            if (nPrice > work[r-1][k.SmaxMax]) TrendMax =  1;
            if (nPrice < work[r-1][k.SminMax]) TrendMax = -1;
            if (nPrice > work[r-1][k.SmaxMid]) TrendMid =  1;
            if (nPrice < work[r-1][k.SminMid]) TrendMid = -1;

            if (TrendMin > 0 && work[r][k.SminMin] < work[r-1][k.SminMin]) work[r][k.SminMin] = work[r-1][k.SminMin];
            if (TrendMin < 0 && work[r][k.SmaxMin] > work[r-1][k.SmaxMin]) work[r][k.SmaxMin] = work[r-1][k.SmaxMin];
            if (TrendMax > 0 && work[r][k.SminMax] < work[r-1][k.SminMax]) work[r][k.SminMax] = work[r-1][k.SminMax];
            if (TrendMax < 0 && work[r][k.SmaxMax] > work[r-1][k.SmaxMax]) work[r][k.SmaxMax] = work[r-1][k.SmaxMax];
            if (TrendMid > 0 && work[r][k.SminMid] < work[r-1][k.SminMid]) work[r][k.SminMid] = work[r-1][k.SminMid];
            if (TrendMid < 0 && work[r][k.SmaxMid] > work[r-1][k.SmaxMid]) work[r][k.SmaxMid] = work[r-1][k.SmaxMid];

            if (TrendMin > 0) linemin = work[r][k.SminMin] + StepSizeMin;
            if (TrendMin < 0) linemin = work[r][k.SmaxMin] - StepSizeMin;
            if (TrendMax > 0) linemax = work[r][k.SminMax] + StepSizeMax;
            if (TrendMax < 0) linemax = work[r][k.SmaxMax] - StepSizeMax;
            if (TrendMid > 0) linemid = work[r][k.SminMid] + StepSizeMid;
            if (TrendMid < 0) linemid = work[r][k.SmaxMid] - StepSizeMid;

         //
         //
         //
         //
         //
               
         work[r][k.TrendMin] = TrendMin;
         work[r][k.TrendMid] = TrendMid;
         work[r][k.TrendMax] = TrendMax;
         work[r][k.linemin]  = linemin;
         work[r][k.linemid]  = linemid;
         work[r][k.linemax]  = linemax;
            
         //
         //
         //
         //
         //
         
         double bsmin = linemax - StepSizeMax;
         double bsmax = linemax + StepSizeMax;
         if (bsmax!=bsmin)
         {
            stoch1[i] = ((linemin - bsmin) / (bsmax - bsmin)) * 100.0;
            stoch2[i] = ((linemid - bsmin) / (bsmax - bsmin)) * 100.0;
         }
         else               
         {
            stoch1[i] = 0;
            stoch2[i] = 0;
         }
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}